//Version 1.1
var eplFormats = {
    bannerGenerico: "bannerGenerico",
    bannerSkin: "bannerSkin",
    layerGenerico: "layerGenerico",
    bannerLayer: "bannerLayer",
    layerBoton: "layerBoton",
    layerScroll: "layerScroll",
    anuncioPrevio: "anuncioPrevio",
    unionLayers: "unionLayers",
    expandibleMultiple: "expandibleMultiple",
    folding: "folding",
    expandiblePush: "expandiblePush",
    expandibleRollover: "expandibleRollover",
    takeover: "takeover",
    zocalo: "zocalo",
    tripleImpacto: "tripleImpacto",
    multipleImpacto: "multipleImpacto",
    quintupleImpacto: "quintupleImpacto",
    inline: "inline",
    filmstrip: "filmstrip"
};

function eplBuilder() {
    
    function ext(o){function a(){}a.prototype = o;return new a();}

    //FORMATOS - comienzo
    function Ad() {}
    Ad.prototype.videoCount = 0;
    Ad.prototype.videos = [];
    Ad.prototype.isComplete = false;
    Ad.prototype.getBannerId = function () {
        if (typeof bannerId !== "undefined") {
            return bannerId;
        } else {
            console.log("Error: la variable bannerId no esta definida");
            return;
        }
    };
    Ad.prototype.adComplete = function () {
        console.log("anuncio Completo");
        parent.eplDoc.eplTH.anuncioCompleto(this.getBannerId(), 1);
        Ad.prototype.isComplete = true;
    };
    Ad.prototype.adCustomAction = function (id) {
        console.log("accion custom [" + id + "]");
        parent.eplDoc.eplTH.customAction(this.getBannerId(), id);
    };
    Ad.prototype.adStartTimer = function () {
        parent.eplDoc.eplTH.timerStart(this.getBannerId());
    };
    Ad.prototype.adStopTimer = function () {
        parent.eplDoc.eplTH.timerStop(this.getBannerId());
    };
    Ad.prototype.setVideo = function (vid) {
        var v = document.getElementById(vid);
        var c = Ad.prototype.isComplete;
        if (this.videoCount > 4) {
            console.log("máximo videos soportados 5");
            return;
        } else {
            Ad.prototype.videos[Ad.prototype.videoCount] = v;
            Ad.prototype.videoCount++;
        }
        v.onplay = function () {
            if (!c) {
                parent.eplDoc.eplTH.start(Ad.prototype.getBannerId());
            } else {
                parent.eplDoc.eplTH.restart(Ad.prototype.getBannerId());
            }

        };

        v.onpause = function () {
            parent.eplDoc.eplTH.stop(Ad.prototype.getBannerId());
        };

        v.onended = function () {
            if (!c) {
                c = true;
                Ad.prototype.adComplete();
            }
        };

        v.onvolumechange = function () {
            if (v.muted) {
                parent.eplDoc.eplTH.soundOff(Ad.prototype.getBannerId());
            } else if (v.volume > 0) {
                parent.eplDoc.eplTH.soundOn(Ad.prototype.getBannerId());
            }
        };
    };
    Ad.prototype.getVideo = function (vNumber) {
        return Ad.prototype.videos[vNumber];
    };

    //Banner Generico
    function BannerGenerico() {
    }
    BannerGenerico.prototype = ext(Ad.prototype);

    //Banner con Skin
    function BannerSkin() {

    }
    BannerSkin.prototype = ext(Ad.prototype);
    BannerSkin.prototype.adShowSkin = function (id, fixed) {
        if (fixed) {
            parent.document.body.style['background-attachment'] = 'fixed';
        } else {
            parent.document.body.style['background-attachment'] = 'scroll';
        }
        parent.eplShowSkin(this.getBannerId(), id);
    };

    //Layer Generico
    function LayerGenerico() {

    }
    LayerGenerico.prototype = ext(Ad.prototype);
    LayerGenerico.prototype.adComplete = function () {
        console.log("anuncio Completo");
        parent.eplHideLayer(this.getBannerId(), 1);
    };
    LayerGenerico.prototype.adClose = function () {
        console.log("cerrar anuncio");
        parent.eplHideLayer(this.getBannerId());
    };

    //Banner a Layer
    function BannerLayer() {

    }
    BannerLayer.prototype = ext(Ad.prototype);
    BannerLayer.prototype.adComplete = function () {
        console.log("anuncio Completo");
        parent.eplAMB2LHideLayer(this.getBannerId(), 1);
    };
    BannerLayer.prototype.adClose = function () {
        console.log("cerrar anuncio");
        parent.eplAMB2LHideLayer(this.getBannerId());
    };
    BannerLayer.prototype.adExpand = function () {
        console.log("expandir anuncio");
        parent.eplAMB2LShowLayer(this.getBannerId());
    };

    //Layer a Boton
    function LayerBoton() {

    }
    LayerBoton.prototype = ext(Ad.prototype);
    LayerBoton.prototype.adComplete = function () {
        console.log("anuncio Completo");
        parent.eplSwapButton(this.getBannerId(), 1);
    };
    LayerBoton.prototype.adClose = function () {
        console.log("cerrar anuncio");
        parent.eplSwapButton(this.getBannerId());
    };

    //Layer con Scroll
    function LayerScroll() {

    }
    LayerScroll.prototype = ext(LayerGenerico.prototype);
    LayerScroll.prototype.adComplete = function () {
        console.log("anuncio Completo");
        parent.eplDoc.eplTH.anuncioCompleto(this.getBannerId(), 1);
    };

    function AnuncioPrevio() {

    }
    AnuncioPrevio.prototype = ext(Ad.prototype);
    AnuncioPrevio.prototype.adComplete = function () {
        console.log("anuncio Completo");
        parent.eplHideLayer(this.getBannerId());
    };
    AnuncioPrevio.prototype.adClose = function () {
        console.log("cerrar anuncio");
        parent.eplPVExitLayer(this.getBannerId(), 1);
    };

    //Union de Layers
    function UnionLayers() {

    }
    UnionLayers.prototype = ext(Ad.prototype);
    UnionLayers.prototype.adComplete = function () {
        console.log("anuncio Completo");
        parent.eplHideCenterLayer(this.getBannerId(), 1);
    };
    UnionLayers.prototype.adJoin = function () {
        console.log("join layers");
        parent.eplJoinLayers(this.getBannerId());
    };
    UnionLayers.prototype.adClose = function () {
        console.log("cerrar anuncio");
        parent.eplHideLeftRightLayers(this.getBannerId());
        parent.eplHideCenterLayer(this.getBannerId());
    };

    //Expandible Multiple
    function ExpandibleMultiple() {

    }
    ExpandibleMultiple.prototype = ext(Ad.prototype);
    ExpandibleMultiple.prototype.adComplete = function () {
        console.log("anuncio completo");
        parent.eplHBVShrinkLayer(this.getBannerId(), 1);
    };
    ExpandibleMultiple.prototype.adShrink = function () {
        console.log("replegar anuncio");
        parent.eplHBVShrinkLayer(this.getBannerId());
    };
    ExpandibleMultiple.prototype.adExpand = function () {
        console.log("expandir anuncio");
        parent.eplHBVExpandLayer(this.getBannerId());
    };

    function Folding() {
    }
    Folding.prototype = ext(ExpandibleMultiple.prototype);
    Folding.prototype.isAnimating = false;
    Folding.prototype.setImages = function(im1,im2,im3,im4,im5,im6){
        Folding.prototype.img1 = document.getElementById(im1);
        Folding.prototype.img2 = document.getElementById(im2);
        Folding.prototype.img3 = document.getElementById(im3);
        Folding.prototype.img4 = document.getElementById(im4);
        Folding.prototype.img5 = document.getElementById(im5);
        Folding.prototype.img6 = document.getElementById(im6);
        
        Folding.prototype.img1.width = "0";
        Folding.prototype.img2.width = "0";
        Folding.prototype.img3.width = "0";
        Folding.prototype.img4.width = "0";
        Folding.prototype.img5.width = "0";
        Folding.prototype.img6.width = "0";
    };
    Folding.prototype.initAnimation = function (fps) {
        if (!Folding.prototype.isAnimating) {
            Folding.prototype.isAnimating = true;
            var v = (typeof fps !== "undefined") ? parseInt(1000 / fps) : 24;
            function an(o) {
                var q = parseInt(o.width);
                var f = setInterval(function () {
                    q = q + 10;
                    o.width = q;
                    //console.log(q);
                    if (q >= 300) {
                        console.log(o.id + " terminado");
                        clearInterval(f);
                        document.body.dispatchEvent(new Event(o.id + "initEnded"));
                        return;
                    }
                }, v);
            }
            an(Folding.prototype.img1);
            document.body.addEventListener(Folding.prototype.img1.id + "initEnded", function () {
                an(Folding.prototype.img2);
            });
            document.body.addEventListener(Folding.prototype.img2.id + "initEnded", function () {
                an(Folding.prototype.img3);
            });
            document.body.addEventListener(Folding.prototype.img3.id + "initEnded", function () {
                an(Folding.prototype.img4);
            });
            document.body.addEventListener(Folding.prototype.img4.id + "initEnded", function () {
                an(Folding.prototype.img5);
            });
            document.body.addEventListener(Folding.prototype.img5.id + "initEnded", function () {
                an(Folding.prototype.img6);
            });
            document.body.addEventListener(Folding.prototype.img6.id + "initEnded", function () {
                Folding.prototype.isAnimating = false;
                console.log(Folding.prototype.isAnimating);
            });
        } else {
            console.log("Animando Folding.....espere");
        }

    };
    Folding.prototype.endAnimation = function (fps) {
        console.log(Folding.prototype.isAnimating);
        if (!Folding.prototype.isAnimating) {
            Folding.prototype.isAnimating = true;
            Folding.prototype.img1.width = "300";
            Folding.prototype.img2.width = "300";
            Folding.prototype.img3.width = "300";
            Folding.prototype.img4.width = "300";
            Folding.prototype.img5.width = "300";
            Folding.prototype.img6.width = "300";
            var v = (typeof fps !== "undefined") ? parseInt(1000 / fps) : 24;
            function an(o) {
                var q = parseInt(o.width);
                var f = setInterval(function () {
                    q = q - 10;
                    o.width = q;
                    //console.log(q);
                    if (q <= 0) {
                        console.log(o.id + " terminado");
                        clearInterval(f);
                        document.body.dispatchEvent(new Event(o.id + "ended"));
                        return;
                    }
                }, v);
            }
            an(Folding.prototype.img6);
            document.body.addEventListener(Folding.prototype.img6.id + "ended", function () {
                an(Folding.prototype.img5);
            });
            document.body.addEventListener(Folding.prototype.img5.id + "ended", function () {
                an(Folding.prototype.img4);
            });
            document.body.addEventListener(Folding.prototype.img4.id + "ended", function () {
                an(Folding.prototype.img3);
            });
            document.body.addEventListener(Folding.prototype.img3.id + "ended", function () {
                an(Folding.prototype.img2);
            });
            document.body.addEventListener(Folding.prototype.img2.id + "ended", function () {
                an(Folding.prototype.img1);
            });
            document.body.addEventListener(Folding.prototype.img1.id + "ended", function () {
                Folding.prototype.isAnimating = false;
                Folding.prototype.adComplete();
            });
        } else {
            console.log("Animando Folding.....espere");
        }

    };


    //Expandible Push
    function ExpandiblePush() {
    }
    ExpandiblePush.prototype = ext(Ad.prototype);
    ExpandiblePush.prototype.initExpanded = function () {
        if (typeof eplEBExpanded !== "undefined") {
            return eplEBExpanded;
        } else {
            console.log("Error: la variable eplEBExpanded no esta definida");
            return;
        }
    };
    ExpandiblePush.prototype.adShrink = function () {
        console.log("replegar anuncio");
        parent.eplEBShrinkLayer(this.getBannerId());
    };
    ExpandiblePush.prototype.adExpand = function () {
        console.log("expandir anuncio");
        parent.eplEBExpandLayer(this.getBannerId());
    };
    ExpandiblePush.prototype.adComplete = function () {
        console.log("anuncio completo");
        parent.eplDoc.eplTH.anuncioCompleto(this.getBannerId(), 1);
        parent.eplEBShrinkLayer(this.getBannerId());
    };

    //Expandible Rollover
    function ExpandibleRollover() {

    }
    ExpandibleRollover.prototype = ext(Ad.prototype);
    ExpandibleRollover.prototype.adExpand = function () {
        console.log("expandir anuncio");
        parent.eplAMROExpandLayer(this.getBannerId());
    };
    ExpandibleRollover.prototype.adShrink = function () {
        console.log("replegar anuncio");
        parent.eplAMROShrinkLayer(this.getBannerId());
    };

    //Takeover
    function Takeover() {

    }
    Takeover.prototype = ext(Ad.prototype);
    Takeover.prototype.adComplete = function () {
        console.log("anuncio completo");
        parent.eplTOExitLayer(this.getBannerId(), 0);
    };
    Takeover.prototype.adClose = function () {
        console.log("cerrar anuncio");
        parent.eplTOExitLayer(this.getBannerId(), 1);
    };
    Takeover.prototype.adExpand = function () {
        console.log("expandir anuncio");
        parent.eplTORestartShow(this.getBannerId());
    };

    //Zocalo
    function Zocalo() {

    }
    Zocalo.prototype = ext(Ad.prototype);
    Zocalo.prototype.adComplete = function () {
        console.log("anuncio completo");
        parent.eplZocaloShrink(1);
    };
    Zocalo.prototype.adExpand = function () {
        console.log("expandir anuncio");
        parent.eplZocaloExpand(this.getBannerId());
    };
    Zocalo.prototype.adShrink = function () {
        console.log("replegar anuncio");
        parent.eplZocaloShrink(0);
    };
    Zocalo.prototype.adClose = function () {
        console.log("cerrar anuncio");
        parent.eplZocaloClose();
    };

    //Triple Impacto
    function TripleImpacto() {

    }
    TripleImpacto.prototype = ext(Ad.prototype);
    TripleImpacto.prototype.adComplete = function () {
        console.log("anuncio completo");
        parent.epl2BLHideLayer(this.getBannerId(), 1);
    };
    TripleImpacto.prototype.adShowLeft = function () {
        console.log("show left");
        parent.epl2BLShowButton(this.getBannerId(), null);
    };
    TripleImpacto.prototype.adShowRight = function () {
        console.log("show right");
        parent.epl2BLShowBanner(this.getBannerId(), null);
    };
    TripleImpacto.prototype.adShowLayer = function () {
        console.log("show layer");
        parent.epl2BLShowLayer(this.getBannerId(), null);
    };

    TripleImpacto.prototype.adHideLeft = function () {
        console.log("hide left");
        parent.epl2BLHideBanner(this.getBannerId(), null);
    };
    TripleImpacto.prototype.adHideRight = function () {
        console.log("hide right");
        parent.epl2BLHideButton(this.getBannerId(), null);  
    };
    TripleImpacto.prototype.adHideLayer = function () {
        console.log("hide layer");
        parent.epl2BLHideLayer(this.getBannerId(), null);
    };

    //Multiple Impacto
    function MultipleImpacto() {

    }
    MultipleImpacto.prototype = ext(Ad.prototype);
    MultipleImpacto.prototype.adComplete = function () {
        console.log("anuncio completo");
        parent.eplMIHideLayer(this.getBannerId(), 1);
    };
    MultipleImpacto.prototype.adShowLeft = function () {
        console.log("show left");
        parent.eplMIShowButton(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adShowRight = function () {
        console.log("show right");
        parent.eplMIShowTop(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adShowTop = function () {
        console.log("show top");
        parent.eplMIShowBanner(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adShowLayer = function () {
        console.log("show layer");
        parent.eplMIShowLayer(this.getBannerId(), null);
    };
    //
    MultipleImpacto.prototype.adHideLeft = function () {
        console.log("hide left");
        parent.eplMIHideButton(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adHideRight = function () {
        console.log("hide right");
        parent.eplMIHideTop(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adHideTop = function () {
        console.log("hide top");
        parent.eplMIHideBanner(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adHideLayer = function () {
        console.log("hide layer");
        parent.eplMIHideLayer(this.getBannerId(), null);
    };

    //Quintuple Impacto
    function QuintupleImpacto() {

    }
    QuintupleImpacto.prototype = ext(Ad.prototype);
    QuintupleImpacto.prototype.adComplete = function () {
        console.log("anuncio completo");
        parent.eplMIHideLayer(this.getBannerId(), 1);
    };
    QuintupleImpacto.prototype.adShowLeft = function () {
        console.log("show left");
        parent.eplMI5ShowButton(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adShowRight = function () {
        console.log("show right");
        parent.eplMI5ShowTop(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adShowTop = function () {
        console.log("show top");
        parent.eplMI5ShowBanner(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adShowBottom = function () {
        console.log("show bottom");
        parent.eplMI5ShowBox(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adShowLayer = function () {
        console.log("show layer");
        parent.eplMI5ShowLayer(this.getBannerId(), null);
    };
    //
    QuintupleImpacto.prototype.adHideLeft = function () {
        console.log("hide left");
        parent.eplMI5HideButton(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adHideRight = function () {
        console.log("hide right");
        parent.eplMI5HideTop(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adHideTop = function () {
        console.log("hide top");
        parent.eplMI5HideBanner(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adHideBottom = function () {
        console.log("hide bottom");
        parent.eplMI5HideBox(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adHideLayer = function () {
        console.log("hide layer");
        parent.eplMI5HideLayer(this.getBannerId(), null);
    };

    //Inline
    function Inline() {
    }
    Inline.prototype = ext(ExpandiblePush.prototype);
    Inline.prototype.adComplete = function () {
        console.log("anuncio completo");
        parent.eplDoc.eplTH.anuncioCompleto(this.getBannerId(), 1);
        parent.eplEBShrinkLayer(this.getBannerId());
        var a = parent.document.getElementById(window.name);
        setTimeout(function(){a.parentElement.remove();}, 1500);
    };
    Inline.prototype.setVideoInline = function (vid) {
        this.setVideo(vid);
        var v2 = this.getVideo(0);

        function eplSoundOn() {
            v2.muted = false;
            v2.volume = 1;
        }

        function eplSoundOff() {
            v2.volume = 0;
            v2.muted = true;
        }

        v2.onended = function(){
            Inline.prototype.adComplete();
        };

        v2.onmouseover = function () {
            eplSoundOn();
        };

        v2.onmouseout = function () {
            eplSoundOff();
        };

    };
    
    //Filmstrip
    function Filmstrip(){
        //console.log("Filmstrip");
    }
    Filmstrip.prototype = ext(Ad.prototype);
    Filmstrip.prototype.setContent = function(divContenedor, divContenido){
        var a = document.getElementById(divContenedor);
        var b = document.getElementById(divContenido);
        a.onmousemove = function(e){
            var aAlto = parseInt(a.style.height.replace("px",""));
            var bAlto = parseInt(b.style.height.replace("px",""));
            var r = (bAlto - aAlto) / aAlto;
            var r2 =  - e.clientY * r;
            b.style["margin-top"] = r2 + "px";
        };
    };

    //FORMATOS - fin

    //FACTORY - comienzo
    function adFactory() {
        this.formatosRegistrados = [];
    }
    adFactory.prototype.registrarFormato = function (id, formato) {
        this.formatosRegistrados[id] = formato;
    };
    adFactory.prototype.create = function (type) {
        return new this.formatosRegistrados[type];
    };

    //registro de clases de formatos al factory
    var factory = new adFactory();
    factory.registrarFormato(eplFormats.bannerGenerico, BannerGenerico);
    factory.registrarFormato(eplFormats.bannerSkin, BannerSkin);
    factory.registrarFormato(eplFormats.layerGenerico, LayerGenerico);
    factory.registrarFormato(eplFormats.bannerLayer, BannerLayer);
    factory.registrarFormato(eplFormats.layerBoton, LayerBoton);
    factory.registrarFormato(eplFormats.layerScroll, LayerScroll);
    factory.registrarFormato(eplFormats.anuncioPrevio, AnuncioPrevio);
    factory.registrarFormato(eplFormats.unionLayers, UnionLayers);
    factory.registrarFormato(eplFormats.expandibleMultiple, ExpandibleMultiple);
    factory.registrarFormato(eplFormats.folding, Folding);
    factory.registrarFormato(eplFormats.expandiblePush, ExpandiblePush);
    factory.registrarFormato(eplFormats.expandibleRollover, ExpandibleRollover);
    factory.registrarFormato(eplFormats.takeover, Takeover);
    factory.registrarFormato(eplFormats.zocalo, Zocalo);
    factory.registrarFormato(eplFormats.tripleImpacto, TripleImpacto);
    factory.registrarFormato(eplFormats.multipleImpacto, MultipleImpacto);
    factory.registrarFormato(eplFormats.quintupleImpacto, QuintupleImpacto);
    factory.registrarFormato(eplFormats.inline, Inline);
    factory.registrarFormato(eplFormats.filmstrip, Filmstrip);
    //FACTORY - fin
    this.create = function (type) {
        return factory.create(type);
    };
}